"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const flag_1 = require("./flag");
const utils_1 = require("./utils");
const validate_1 = require("./validate");
const vality_1 = require("./vality");
vality_1.vality.from = (key) => flag_1.flag("from", key, (e) => (val, _options, context, path, parent) => utils_1.enyToGuardFn(e)(val, context, path, parent));
vality_1.vality.optional = flag_1.flag("optional", true, (e) => (val, options, context, path, parent) => {
    const enyVal = utils_1.enyToGuardFn(e)(val, context, path, parent);
    if (enyVal.valid)
        return enyVal;
    if (val === undefined)
        return { valid: true, data: undefined, errors: [] };
    const { strict } = validate_1.mergeOptions(options, context, ["strict"]);
    if (!strict && val === null)
        return { valid: true, data: undefined, errors: [] };
    return enyVal;
});
vality_1.vality.virtual = flag_1.flag("virtual", true, (e) => (val, _options, _context, path) => {
    if (val === undefined)
        return {
            valid: true,
            data: undefined,
            errors: [],
        };
    return {
        valid: false,
        data: undefined,
        errors: [
            {
                message: "vality.virtual.base",
                path,
                options: {},
                value: val,
            },
        ],
    };
});
//# sourceMappingURL=flags.js.map